//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_color3 DarkGray
#property indicator_color4 DarkGray
#property indicator_minimum 0
#property indicator_maximum 1


extern string TimeFrame   = "current time frame";
extern double CCI_Period  = 13;
extern int    CCI_Price   = 5;
extern int	  Overbought  = 50;
extern int	  Oversold    = -50;
extern bool   DrawWicks   = true;

//

double hiu[];
double hid[];
double hnu[];
double hnd[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
//---- indicators
	IndicatorShortName("RP: ("+	CCI_Period+")");
	SetIndexBuffer(0,hiu); SetIndexStyle(0,DRAW_HISTOGRAM);
	SetIndexBuffer(1,hid); SetIndexStyle(1,DRAW_HISTOGRAM);
	SetIndexBuffer(2,hnu); SetIndexStyle(2,DRAW_HISTOGRAM);
	SetIndexBuffer(3,hnd); SetIndexStyle(3,DRAW_HISTOGRAM);
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame=="returnBars"); 
         timeFrame         = stringToTimeFrame(TimeFrame);
	return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-2);
         if (returnBars) { hiu[0] = limit; return(0); }
         if (timeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //
   
	for(int i = limit; i>=0; i--)
	{
      int y = iBarShift(NULL,timeFrame,Time[i]);	
		   double cci   = iCCI(NULL,timeFrame,CCI_Period,CCI_Price,y);
		   int    state = 0;
				if(cci > Overbought)	state = 1;
				if(cci < Oversold)	state =-1;
				
				hiu[i] = EMPTY_VALUE; hid[i] = EMPTY_VALUE; hnu[i] = EMPTY_VALUE; hnd[i] = EMPTY_VALUE;
				if (DrawWicks)
				{
				   if (state== 1) { hiu[i] = High[i];  hid[i] = Low[i]; }
   				if (state==-1) { hid[i] = High[i];  hiu[i] = Low[i]; }
			   	if (state== 0) { hnu[i] = High[i];  hnd[i] = Low[i]; }
            }
            else			   	
            {
				   if (state== 1) { hiu[i] = MathMax(Open[i],Close[i]);  hid[i] = MathMin(Open[i],Close[i]); }
   				if (state==-1) { hid[i] = MathMax(Open[i],Close[i]);  hiu[i] = MathMin(Open[i],Close[i]); }
			   	if (state== 0) { hnu[i] = MathMax(Open[i],Close[i]);  hnd[i] = MathMin(Open[i],Close[i]); }
            }
	}
	return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}